#!/bin/bash
# This script will show the lyrics of the selected song in 
# a kdialog box.
# Thanks to madpenguin8 (mdiehl) for the idea, parts of the
# implementation, the dcop call, and a loose script to base this on.
# Thanks also to the kind folks in #lfs-support that took the time
# to help me with various sed-ism's, me being uninitiated as I am
# Special thanks to them for putting up with me trying to remove
# <br> when I should have checked for <br />
function begin () 	 #Add in custom menu choice here and notify user
{
	dcop amarok script addCustomMenuItem "Lyrics" "view"
	dcop amarok playlist shortStatusMessage "Lyrics Viewer Loaded"
}

function onClose () # Clean out script when closed
{
	dcop amarok script removeCustomMenuItem "Lyrics" "view"
	dcop amarok playlist shortStatusMessage "Lyrics Viewer Unloaded"
	rm .lyrics_final
	exit 0
}

function getLyrics ()
{
	for song in ${SONG_LIST}
	do
		#kfmexec "dcop amarok player lyricsByPath" $song | sed -e s'~<br
		#\/>~~g' -e s'~<\/body>~~' -e s'~<\/html>~~' | tee .lyrics_final
		kfmexec "dcop amarok player lyricsByPath" $song | html2text	-nobs | tee .lyrics_final
		if [ -n "$(cat .lyrics_final)" ] ; then	
			kdialog --icon amarok --title "View Lyrics"  --textbox .lyrics_final 225 500
		else 
			kdialog --icon amarok --title "View Lyrics" --error "You need to get the lyrics for this song first!"
		fi
		
	done
}

begin

while [ 1 ]
	
	trap onClose SIGTERM

do
	
	read input
	
	lyrics=`echo $input | grep "Lyrics"`
	SONG_LIST=`echo $lyrics | sed s'~customMenuClicked: Lyrics view~~g'	` #remove cruft

	if [ "$SONG_LIST" > 0 ]; then
		getLyrics
	fi
done

exit 0

